#!/gpfs/apps/MN5/GPP/PYTHON/3.12.1/INTEL/bin/python3

import sys
import numpy as np
from read_utils import *
import matplotlib.pyplot as plt

def main():
    #Argument parsing:
    if len(sys.argv) < 2:
        print("Usae: python script.py <root rundir>")
        sys.exit(1)

    root_folder = sys.argv[1]
    plot_one_by_one = False
    

    # Search for rundirs:
    rundirs = find_rundirs_folders(root_folder)
    rundirs = sorted(rundirs)
    results = {}
    for rundir in rundirs:
        ts_completed = get_timesteps(rundir)
        print(f"Found rundir at {rundir} with {ts_completed} timesteps")

        ts_time_dict = get_timestep_timings(rundir, ts_completed)
        steps = list(ts_time_dict.keys())
        times = list(ts_time_dict.values())

        print(f"max: {np.max(times)} min: {np.min(times)}  avg: {np.average(times)}")
        
        if plot_one_by_one:
            plt.figure(figsize=(10, 6))
            #plt.plot(steps, times, marker='o', linestyle='-')
            plt.bar(steps, times, color='blue')
            plt.title('Time per step')
            plt.xlabel('Timestep')
            plt.ylabel('Time(s)')
            plt.grid(True)
            plt.tight_layout()
            plt.show()

        results[rundir] = ts_time_dict


        plt.plot(steps, times, label=str(rundir), linestyle='', marker='s', markersize=4)

    #plt.legend()
    plt.tight_layout()
    plt.show()
    plt.savefig('steps.png')


if __name__ == "__main__":
    main()
